p4pdes
======

_PETSc for Partial Differential Equations_ is a new book on using [PETSc](https://petsc.org/release/) to solve [partial differential equations](https://en.wikipedia.org/wiki/Partial_differential_equation) by modern numerical methods.

<p align="center">
  <a  href="https://my.siam.org/Store/Product/viewproduct/?ProductId=32850137"> <img src="frontcover.jpg" alt="image of front cover" /img> </a>
</p>

Order the paper book from [SIAM Press](https://my.siam.org/Store/Product/viewproduct/?ProductId=32850137) or the e-book from [Google Play](https://play.google.com/store/books/details/Ed_Bueler_PETSc_for_Partial_Differential_Equations?id=tgMHEAAAQBAJ).

This repository contains the C and Python example programs upon which the book is based.  They will remain here for the long term, and be maintained for future versions of PETSc.

### C examples

To compile and run the C examples, for Chapters 1 through 12, see the [`README.md`](c/README.md) in the `c/` directory.

### Python/Firedrake examples

Chapters 13 and 14 use [Firedrake](https://www.firedrakeproject.org/), a [Python](https://www.python.org/) finite element library based on PETSc.  See the [`README.md`](python/README.md) in the `python/` directory to run these examples.

